Index: kernel/genarch/include/genarch/drivers/ns16550/ns16550.h
===================================================================
--- kernel/genarch/include/genarch/drivers/ns16550/ns16550.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/include/genarch/drivers/ns16550/ns16550.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -43,25 +43,9 @@
 #include <console/chardev.h>
 
-#define NS156440_CLOCK    115200 /** Internal clock speed, max. baud rate. */
+#define IER_ERBFI  0x01  /** Enable Receive Buffer Full Interrupt. */
 
-#define IER_ERBFI         0x01   /** Enable Receive Buffer Full Interrupt. */
-#define MCR_OUT2          0x08   /** OUT2. */
+#define LCR_DLAB   0x80  /** Divisor Latch Access bit. */
 
-#define LCR_DLAB          0x80   /** Divisor Latch Access bit. */
-#define LCR_SBE           0x40   /** RS-232 Break Signal bit. */
-
-#define LCR_PARITY_NONE   0x00   /** No parity bit. */
-#define LCR_PARITY_ODD    0x08   /** Odd parity. */
-#define LCR_PARITY_EVEN   0x18   /** Even parity. */
-#define LCR_PARITY_MARK   0x28   /** Parity bit always one. */
-#define LCR_PARITY_SPACE  0x38   /** Parity bit always zero. */
-
-#define LCR_STOP_BIT_ONE  0x00   /** One stop bit. */
-#define LCR_STOP_BIT_TWO  0x04   /** Two stop bits. */
-
-#define LCR_WORD_LEN_5    0x00   /** 5-bit word length. */
-#define LCR_WORD_LEN_6    0x01   /** 6-bit word length. */
-#define LCR_WORD_LEN_7    0x02   /** 7-bit word length. */
-#define LCR_WORD_LEN_8    0x03   /** 8-bit word length. */
+#define MCR_OUT2   0x08  /** OUT2. */
 
 /** NS16550 registers. */
@@ -69,7 +53,5 @@
 	NS16550_REG_RBR = 0,  /**< Receiver Buffer Register (read). */
 	NS16550_REG_THR = 0,  /**< Transmitter Holder Register (write). */
-	NS16550_REG_DLL = 0,  /**< Baud rate divisor latch low byte (write). */
 	NS16550_REG_IER = 1,  /**< Interrupt Enable Register. */
-	NS16550_REG_DLH = 1,  /**< Baud rate divisor latch high byte (write). */
 	NS16550_REG_IIR = 2,  /**< Interrupt Ident Register (read). */
 	NS16550_REG_FCR = 2,  /**< FIFO control register (write). */
@@ -91,5 +73,4 @@
 extern ns16550_instance_t *ns16550_init(ioport8_t *, unsigned, inr_t, cir_t,
     void *, outdev_t **);
-extern void ns16550_format_set(ns16550_instance_t *, unsigned, uint8_t);
 extern void ns16550_wire(ns16550_instance_t *, indev_t *);
 
Index: kernel/genarch/src/drivers/bcm2835/mbox.c
===================================================================
--- kernel/genarch/src/drivers/bcm2835/mbox.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/drivers/bcm2835/mbox.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -86,5 +86,5 @@
 }
 
-bool bcm2835_fb_init(fb_properties_t *prop, uint32_t width, uint32_t height)
+bool bcm2835_fb_init(fb_properties_t *prop)
 {
 	bcm2835_mbox_t *fb_mbox;
@@ -95,6 +95,6 @@
 	    KM_NATURAL_ALIGNMENT, PAGE_NOT_CACHEABLE);
 
-	fb_desc->width = width;
-	fb_desc->height = height;
+	fb_desc->width = 640;
+	fb_desc->height = 480;
 	fb_desc->virt_width = fb_desc->width;
 	fb_desc->virt_height = fb_desc->height;
@@ -128,35 +128,4 @@
 }
 
-bool bcm2835_mbox_get_fb_size(uint32_t *w, uint32_t *h)
-{
-	bool r;
-	MBOX_BUFF_ALLOC(msg, mbox_getfbsize_buf_t);
-	bcm2835_mbox_t *mbox;
-
-	mbox = (void *) km_map(BCM2835_MBOX0_ADDR, sizeof(bcm2835_mbox_t),
-	    KM_NATURAL_ALIGNMENT, PAGE_NOT_CACHEABLE);
-	assert(mbox);
-
-	msg->buf_hdr.size = sizeof(mbox_getfbsize_buf_t);
-	msg->buf_hdr.code = MBOX_PROP_CODE_REQ;
-	msg->tag_hdr.tag_id = MBOX_TAG_GET_PHYS_W_H;
-	msg->tag_hdr.buf_size = sizeof(msg->body);
-	msg->tag_hdr.val_len  = 0;
-	msg->zero = 0;
-
-	mbox_write(mbox,
-	    MBOX_CHAN_PROP_A2V, KA2VCA((uint32_t)msg));
-	mbox_read(mbox, MBOX_CHAN_PROP_A2V);
-
-	r = msg->buf_hdr.code == MBOX_PROP_CODE_RESP_OK;
-	if (r) {
-		*h = msg->body.height;
-		*w = msg->body.width;
-	}
-
-	km_unmap((uintptr_t) mbox, sizeof(bcm2835_mbox_t));
-	return r;
-}
-
 /**
  * @}
Index: kernel/genarch/src/drivers/ns16550/ns16550.c
===================================================================
--- kernel/genarch/src/drivers/ns16550/ns16550.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/genarch/src/drivers/ns16550/ns16550.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -132,28 +132,4 @@
 };
 
-/** Configure ns16550 transmission format.
- *
- * @param instance   NS 16550 driver instance.
- * @param baud_rate  Transmission speed in bits per second, also known as baud,
- *                   maximum value is 115200.
- * @param lcr_format Line Control Register configuration bits, as defined by
- *                   the @c LCR_ macros.  These configure the word width,
- *                   parity type, and stop bit count.
- */
-void ns16550_format_set(ns16550_instance_t *instance,
-    unsigned baud_rate, uint8_t lcr_format)
-{
-	uint16_t divisor;
-
-	divisor = (uint16_t)(NS156440_CLOCK / baud_rate);
-	if (divisor == 0)
-		divisor = 1;  /* Avoid division by zero. */
-
-	ns16550_reg_write(instance, NS16550_REG_LCR, LCR_DLAB);
-	ns16550_reg_write(instance, NS16550_REG_DLL, divisor & 0xFF);
-	ns16550_reg_write(instance, NS16550_REG_DLH, (divisor >> 8) & 0xFF);
-	ns16550_reg_write(instance, NS16550_REG_LCR, lcr_format & ~LCR_DLAB);
-}
-
 /** Initialize ns16550.
  *
Index: kernel/generic/include/adt/list.h
===================================================================
--- kernel/generic/include/adt/list.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/adt/list.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -95,5 +95,5 @@
 
 #define list_foreach(list, member, itype, iterator) \
-	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) sizeof(itype)) \
+	for (itype *iterator = NULL; iterator == NULL; iterator = &((itype *) NULL)[1]) \
 		for (link_t *_link = (list).head.next; \
 		    iterator = list_get_instance(_link, itype, member), \
@@ -101,5 +101,5 @@
 
 #define list_foreach_rev(list, member, itype, iterator) \
-	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) sizeof(itype)) \
+	for (itype *iterator = NULL; iterator == NULL; iterator = &((itype *) NULL)[1]) \
 		for (link_t *_link = (list).head.prev; \
 		    iterator = list_get_instance(_link, itype, member), \
Index: kernel/generic/include/atomic.h
===================================================================
--- kernel/generic/include/atomic.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/atomic.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -40,4 +40,13 @@
 #include <stdatomic.h>
 
+// TODO: Remove.
+// Before <stdatomic.h> was available, there was only one atomic type
+// equivalent to atomic_size_t. This means that in some places, atomic_t can
+// be replaced with a more appropriate type (e.g. atomic_bool for flags or
+// a signed type for potentially signed values).
+// So atomic_t should be replaced with the most appropriate type on a case by
+// case basis, and after there are no more uses, remove this type.
+typedef atomic_size_t atomic_t;
+
 #define atomic_predec(val) \
 	(atomic_fetch_sub((val), 1) - 1)
Index: kernel/generic/include/cap/cap.h
===================================================================
--- kernel/generic/include/cap/cap.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/cap/cap.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -80,5 +80,5 @@
 typedef struct kobject {
 	kobject_type_t type;
-	atomic_size_t refcnt;
+	atomic_t refcnt;
 
 	/** Mutex protecting caps_list */
Index: kernel/generic/include/cpu.h
===================================================================
--- kernel/generic/include/cpu.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/cpu.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -58,5 +58,5 @@
 	context_t saved_context;
 
-	atomic_size_t nrdy;
+	atomic_t nrdy;
 	runq_t rq[RQ_COUNT];
 	volatile size_t needs_relink;
Index: kernel/generic/include/halt.h
===================================================================
--- kernel/generic/include/halt.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/halt.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -38,5 +38,5 @@
 #include <atomic.h>
 
-extern atomic_bool haltstate;
+extern atomic_t haltstate;
 
 extern void halt(void) __attribute__((noreturn));
Index: kernel/generic/include/ipc/ipc.h
===================================================================
--- kernel/generic/include/ipc/ipc.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/ipc/ipc.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -71,5 +71,5 @@
 	struct call *hangup_call;
 	ipc_phone_state_t state;
-	atomic_size_t active_calls;
+	atomic_t active_calls;
 	/** User-defined label */
 	sysarg_t label;
@@ -90,5 +90,5 @@
 	 * Number of answers the answerbox is expecting to eventually arrive.
 	 */
-	atomic_size_t active_calls;
+	atomic_t active_calls;
 
 	/** Phones connected to this answerbox. */
Index: kernel/generic/include/mm/slab.h
===================================================================
--- kernel/generic/include/mm/slab.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/mm/slab.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -99,9 +99,9 @@
 
 	/* Statistics */
-	atomic_size_t allocated_slabs;
-	atomic_size_t allocated_objs;
-	atomic_size_t cached_objs;
+	atomic_t allocated_slabs;
+	atomic_t allocated_objs;
+	atomic_t cached_objs;
 	/** How many magazines in magazines list */
-	atomic_size_t magazine_counter;
+	atomic_t magazine_counter;
 
 	/* Slabs */
Index: kernel/generic/include/proc/scheduler.h
===================================================================
--- kernel/generic/include/proc/scheduler.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/proc/scheduler.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -52,5 +52,5 @@
 } runq_t;
 
-extern atomic_size_t nrdy;
+extern atomic_t nrdy;
 extern void scheduler_init(void);
 
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/include/proc/task.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -87,7 +87,7 @@
 
 	/** Number of references (i.e. threads). */
-	atomic_size_t refcount;
+	atomic_t refcount;
 	/** Number of threads that haven't exited yet. */
-	atomic_size_t lifecount;
+	atomic_t lifecount;
 
 	/** Task permissions. */
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/console/console.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -379,5 +379,5 @@
 		 * The early_putuchar() function is used to output
 		 * the character for low-level debugging purposes.
-		 * Note that the early_putuchar() function might be
+		 * Note that the early_putc() function might be
 		 * a no-op on certain hardware configurations.
 		 */
Index: kernel/generic/src/lib/halt.c
===================================================================
--- kernel/generic/src/lib/halt.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/lib/halt.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -36,5 +36,4 @@
  */
 
-#include <stdbool.h>
 #include <halt.h>
 #include <log.h>
@@ -45,5 +44,5 @@
 
 /** Halt flag */
-atomic_bool haltstate = false;
+atomic_t haltstate = 0;
 
 /** Halt wrapper
@@ -58,9 +57,9 @@
 
 	if (!atomic_load(&haltstate)) {
-		atomic_store(&haltstate, true);
+		atomic_store(&haltstate, 1);
 		rundebugger = true;
 	}
 #else
-	atomic_store(&haltstate, true);
+	atomic_store(&haltstate, 1);
 #endif
 
Index: kernel/generic/src/mm/frame.c
===================================================================
--- kernel/generic/src/mm/frame.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/mm/frame.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -370,5 +370,4 @@
 {
 	assert(zone->flags & ZONE_AVAILABLE);
-	assert(zone->free_count >= count);
 
 	/* Allocate frames from zone */
@@ -411,9 +410,8 @@
 
 	frame_t *frame = zone_get_frame(zone, index);
+
 	assert(frame->refcount > 0);
 
 	if (!--frame->refcount) {
-		assert(zone->busy_count > 0);
-
 		bitmap_set(&zone->bitmap, index, 0);
 
@@ -434,11 +432,7 @@
 
 	frame_t *frame = zone_get_frame(zone, index);
-	assert(frame->refcount <= 1);
-
 	if (frame->refcount > 0)
 		return;
 
-	assert(zone->free_count > 0);
-
 	frame->refcount = 1;
 	bitmap_set_range(&zone->bitmap, index, 1);
@@ -446,18 +440,4 @@
 	zone->free_count--;
 	reserve_force_alloc(1);
-}
-
-/** Mark frame in zone available to allocation. */
-_NO_TRACE static void zone_mark_available(zone_t *zone, size_t index)
-{
-	assert(zone->flags & ZONE_AVAILABLE);
-
-	frame_t *frame = zone_get_frame(zone, index);
-	assert(frame->refcount == 1);
-
-	frame->refcount = 0;
-	bitmap_set_range(&zone->bitmap, index, 0);
-
-	zone->free_count++;
 }
 
@@ -485,5 +465,4 @@
 	/* Difference between zone bases */
 	pfn_t base_diff = zones.info[z2].base - zones.info[z1].base;
-	pfn_t gap = base_diff - zones.info[z1].count;
 
 	zones.info[z1].count = base_diff + zones.info[z2].count;
@@ -513,13 +492,4 @@
 		    zones.info[z2].frames[i];
 	}
-
-	/*
-	 * Mark the gap between the original zones as unavailable.
-	 */
-
-	for (size_t i = 0; i < gap; i++) {
-		frame_initialize(&zones.info[z1].frames[old_z1->count + i]);
-		zone_mark_unavailable(&zones.info[z1], old_z1->count + i);
-	}
 }
 
@@ -548,5 +518,5 @@
 
 	for (size_t i = 0; i < cframes; i++)
-		zone_mark_available(&zones.info[znum],
+		(void) zone_frame_free(&zones.info[znum],
 		    pfn - zones.info[znum].base + i);
 }
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/proc/scheduler.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -68,5 +68,5 @@
 static void scheduler_separated_stack(void);
 
-atomic_size_t nrdy;  /**< Number of ready threads in the system. */
+atomic_t nrdy;  /**< Number of ready threads in the system. */
 
 /** Carry out actions before new task runs. */
Index: kernel/test/atomic/atomic1.c
===================================================================
--- kernel/test/atomic/atomic1.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/atomic/atomic1.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -32,5 +32,5 @@
 const char *test_atomic1(void)
 {
-	atomic_int a;
+	atomic_t a;
 
 	atomic_store(&a, 10);
Index: kernel/test/mm/falloc2.c
===================================================================
--- kernel/test/mm/falloc2.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/mm/falloc2.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -43,6 +43,6 @@
 #define THREADS      8
 
-static atomic_size_t thread_cnt;
-static atomic_size_t thread_fail;
+static atomic_t thread_cnt;
+static atomic_t thread_fail;
 
 static void falloc(void *arg)
Index: kernel/test/synch/semaphore1.c
===================================================================
--- kernel/test/synch/semaphore1.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/synch/semaphore1.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -41,6 +41,6 @@
 
 static waitq_t can_start;
-static atomic_size_t items_produced;
-static atomic_size_t items_consumed;
+static atomic_t items_produced;
+static atomic_t items_consumed;
 
 static void producer(void *arg)
Index: kernel/test/thread/thread1.c
===================================================================
--- kernel/test/thread/thread1.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/thread/thread1.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -30,5 +30,4 @@
 #include <test.h>
 #include <atomic.h>
-#include <stdbool.h>
 #include <proc/thread.h>
 
@@ -37,6 +36,6 @@
 #define THREADS  5
 
-static atomic_bool finish;
-static atomic_size_t threads_finished;
+static atomic_t finish;
+static atomic_t threads_finished;
 
 static void threadtest(void *data)
@@ -56,5 +55,5 @@
 	size_t total = 0;
 
-	atomic_store(&finish, true);
+	atomic_store(&finish, 1);
 	atomic_store(&threads_finished, 0);
 
@@ -73,5 +72,5 @@
 	thread_sleep(10);
 
-	atomic_store(&finish, false);
+	atomic_store(&finish, 0);
 	while (atomic_load(&threads_finished) < total) {
 		TPRINTF("Threads left: %zu\n", total - atomic_load(&threads_finished));
Index: meson/arch/arm64/meson.build
===================================================================
--- meson/arch/arm64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/arch/arm64/meson.build	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -32,4 +32,5 @@
 arch_uspace_link_args = [ '-nostdlib', '-lgcc' ]
 
+
 # UEFI binaries should be relocatable, the EFI boot service LoadImage() will
 # rebase the boot file using the .reloc information in the image if it cannot
@@ -45,4 +46,5 @@
 arch_boot_link_args = [ '-Wl,-shared', '-Wl,--no-gc-sections' ]
 
+
 if MACHINE == 'virt'
 	rd_essential += [
@@ -52,10 +54,2 @@
 	]
 endif
-
-if MACHINE == 'hikey960'
-	rd_essential += [
-		'drv/char/pl011',
-		'drv/intctl/gicv2',
-		'drv/platform/hikey960',
-	]
-endif
Index: tools/ew.py
===================================================================
--- tools/ew.py	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ tools/ew.py	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -144,20 +144,19 @@
 			return 'system-arm', '-M raspi1ap'
 	elif platform == 'arm64':
-		if machine == 'virt':
-			# Search for the EDK2 firmware image
-			default_paths = (
-				'/usr/local/qemu-efi-aarch64/QEMU_EFI.fd', # Custom
-				'/usr/share/edk2/aarch64/QEMU_EFI.fd',     # Fedora
-				'/usr/share/qemu-efi-aarch64/QEMU_EFI.fd', # Ubuntu
-			)
-			extra_info = ("Pre-compiled binary can be obtained from "
-			    "http://snapshots.linaro.org/components/kernel/leg-virt-tianocore-edk2-upstream/latest/QEMU-AARCH64/RELEASE_GCC5/QEMU_EFI.fd.\n")
-			efi_path = find_firmware(
-			    "EDK2", 'EW_QEMU_EFI_AARCH64', default_paths, extra_info)
-			if efi_path is None:
-				raise Exception
-
-			return 'system-aarch64', \
-			    '-M virt -cpu cortex-a57 -m 1024 -bios %s' % efi_path
+		# Search for the EDK2 firmware image
+		default_paths = (
+			'/usr/local/qemu-efi-aarch64/QEMU_EFI.fd', # Custom
+			'/usr/share/edk2/aarch64/QEMU_EFI.fd',     # Fedora
+			'/usr/share/qemu-efi-aarch64/QEMU_EFI.fd', # Ubuntu
+		)
+		extra_info = ("Pre-compiled binary can be obtained from "
+		    "http://snapshots.linaro.org/components/kernel/leg-virt-tianocore-edk2-upstream/latest/QEMU-AARCH64/RELEASE_GCC5/QEMU_EFI.fd.\n")
+		efi_path = find_firmware(
+		    "EDK2", 'EW_QEMU_EFI_AARCH64', default_paths, extra_info)
+		if efi_path is None:
+			raise Exception
+
+		return 'system-aarch64', \
+		    '-M virt -cpu cortex-a57 -m 1024 -bios %s' % efi_path
 	elif platform == 'ia32':
 		return 'system-i386', pc_options(32)
Index: uspace/app/calculator/calculator.c
===================================================================
--- uspace/app/calculator/calculator.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/calculator/calculator.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -833,16 +833,16 @@
 	if (ui_is_textmode(ui)) {
 		params.rect.p1.x = 38;
-		params.rect.p1.y = 18;
+		params.rect.p1.y = 19;
 
 		calc.geom.menubar_rect.p0.x = 1;
-		calc.geom.menubar_rect.p0.y = 1;
+		calc.geom.menubar_rect.p0.y = 2;
 		calc.geom.menubar_rect.p1.x = params.rect.p1.x - 1;
-		calc.geom.menubar_rect.p1.y = 2;
+		calc.geom.menubar_rect.p1.y = 3;
 		calc.geom.entry_rect.p0.x = 4;
-		calc.geom.entry_rect.p0.y = 3;
+		calc.geom.entry_rect.p0.y = 4;
 		calc.geom.entry_rect.p1.x = 34;
-		calc.geom.entry_rect.p1.y = 4;
+		calc.geom.entry_rect.p1.y = 5;
 		calc.geom.btn_orig.x = 4;
-		calc.geom.btn_orig.y = 5;
+		calc.geom.btn_orig.y = 6;
 		calc.geom.btn_dim.x = 6;
 		calc.geom.btn_dim.y = 2;
@@ -945,5 +945,4 @@
 	ui_entry_set_rect(display, &calc.geom.entry_rect);
 	ui_entry_set_halign(display, gfx_halign_right);
-	ui_entry_set_read_only(display, true);
 
 	rc = ui_fixed_add(fixed, ui_entry_ctl(display));
